﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

/*
 * Generated 12/7/2018 2:48:43 PM
 * Copyright TimH 2018
 * 
 * destinationdirectory:        C:\Users\TimH\Source\Repos\TcHmiProject101\FrameworkControlJs1
 * TcHmi_DefaultParameters:     [$guid1$, b79e94e1-8646-48e9-ad35-16a04652de9b] | [$guid2$, 64567c90-6c04-46eb-a95a-9baf942c91f5] | [$guid3$, c9cf73af-420a-4d07-b630-70de329a0ee8] | [$guid4$, 859d1b6d-a207-45d4-9896-2e5b516eb8e4] | [$guid5$, f0aa831c-5896-487e-af1d-e2c44a3cc2ca] | [$guid6$, 8b0c3c92-900e-4b30-99f3-00f36743ade1] | [$guid7$, 77f96b98-af8c-49c9-a6f6-fe2f9468bb2d] | [$guid8$, 48ede00d-007d-4967-9e0f-f2b701f0b4d1] | [$guid9$, edfeb776-0d6f-45b6-b989-54b3d3efc349] | [$guid10$, a1c18050-5bc0-4cb7-90d1-a0e5318fe030] | [$time$, 12/7/2018 2:48:43 PM] | [$year$, 2018] | [$username$, TimH] | [$userdomain$, BECKHOFF] | [$machinename$, TIMH-NB02] | [$clrversion$, 4.0.30319.42000] | [$registeredorganization$, ] | [$runsilent$, False] | [$solutiondirectory$, C:\Users\TimH\Source\Repos\TcHmiProject101\] | [$projectname$, FrameworkControlJs1] | [$safeprojectname$, FrameworkControlJs1] | [$currentuiculturename$, en-US] | [$installpath$, C:\Program Files (x86)\Microsoft Visual Studio\2017\Professional\Common7\IDE\] | [$specifiedsolutionname$, FrameworkControlJs1] | [$exclusiveproject$, False] | [$destinationdirectory$, C:\Users\TimH\Source\Repos\TcHmiProject101\FrameworkControlJs1] | [$targetframeworkversion$, 4.5]
 * projectname_tchmi:           FrameworkControlJs1
 * projectname_tchmi_dashcase:  framework-control-js1
 * safeprojectname:             FrameworkControlJs1
 * projectname:                 FrameworkControlJs1
 */

/**
*  Namespace: TcHmi
*  [REQUIRED]
*/
(function (TcHmi) {
    /**
    *  Namespace: TcHmi.Controls
    *  [REQUIRED]
    */
    (function (Controls) {
        /**
         *  Namespace: TcHmi.Controls.Custom
         *  [CUSTOM]
         */
        var Custom;
        (function (Custom) {
            /** FrameworkControlJs1 object */
            var FrameworkControlJs1 = (function (_super) {
                __extends(FrameworkControlJs1, _super);

                /*
                Attribute philosophy
                --------------------
                - Local variables are not set while definition in class, so they have the value 'undefined'.
                - On compile the Framework sets the value from HTML or from theme (possibly 'null') via normal setters
                - The "changed detection" in the setter will result in processing the value only once while compile
                - Attention: If we have a Server Binding on an Attribute the setter can be very late or never (leaving the value = undefined).
                */

                /**
                 * @description Constructor of the control
                 * @param {JQuery} element Element from HTML (internal, do not use)
                 * @param {JQuery} pcElement precompiled Element (internal, do not use)
                 * @param {TcHmi.Controls.ControlAttributeList} attrs Attributes defined in HTML in a special format (internal, do not use)
                 * @returns {void}
                 */
                function FrameworkControlJs1(element, pcElement, attrs) {
                    /** Call base constructor */
                    _super.call(this, element, pcElement, attrs);

                }
                /** 
                * @description Is called during control initialize phase before attribute setter are called based on initial html dom values. 
                * @returns {void}
                */
                FrameworkControlJs1.prototype.__previnit = function () {
                    /** Handle template elements. Should be done before call to __previnit of super class. */
                    this.__elementTemplateRoot = this.__element.find('.framework-control-js1-template');
                    
                    /** Call __previnit of super class with the correct instance. */
                    _super.prototype.__previnit.call(this);


                    // For an inline SVG example: uncomment in Source.js and Template.html
                    this.__elementSvgPolygon = this.__elementTemplateRoot.find('.framework-control-js1-template-embedded-svg');

                    // get reference to placeholder element
                    this.__elementSvgPlaceHolder = this.__elementTemplateRoot.find('.framework-control-js1-template-svg-placeholder');

                    // get base path indepent of LiveView or published project
                    var basePath = TcHmi.Environment.getBasePath() + '/Controls/Custom/FrameworkControlJs1/';

                    // set source dependent on the current view
                    $(this.__elementSvgPlaceHolder).attr("src", basePath + "Themes/Base/Images/message_normal.svg");                   
                };
                /** 
                 * @description Is called during control initialize phase after attribute setter have been called based on it's default or initial html dom values. 
                 * @returns {void}
                 */
                FrameworkControlJs1.prototype.__init = function () {
                    /** Call __init of super class with the correct instance. */
                    _super.prototype.__init.call(this);

                };
                /**
                * @description Is called after the control instance gets part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @returns {void}
                */
                FrameworkControlJs1.prototype.__attach = function () {
                    /** Call __attach of super class with the correct instance. */
                    _super.prototype.__attach.call(this);

                    /**
                     * Initialize everything which is only available while the control is part of the active dom.
                     */
                };
                /**
                * @description Is called after the control instance is no longer part of the current DOM.
                * Is only allowed to be called from the framework itself!
                * @returns {void}
                */
                FrameworkControlJs1.prototype.__detach = function () {
                    /** Call __detach of super class with the correct instance. */
                    _super.prototype.__detach.call(this);

                    /**
                     * Disable everything which is not needed while the control is not part of the active dom.
                     * No need to listen to events for example!
                     */
                };
                /**
                * @description Destroy the current control instance. 
                * Will be called automatically if system destroys control!
                * @returns {void}
                */
                FrameworkControlJs1.prototype.destroy = function () {
                    /** Call destroy of super class with the correct instance. */
                    _super.prototype.destroy.call(this);

                    /**
                    * Free resources like child controls etc.
                    */
                };

                return FrameworkControlJs1;
            })(TcHmi.Controls.System.TcHmiControl);
            Custom.FrameworkControlJs1 = FrameworkControlJs1;
        })(Custom = Controls.Custom || (Controls.Custom = {}));
        /**
        * Register control...
        */
        Controls.register('framework-control-js1', Custom.FrameworkControlJs1, 'Custom/FrameworkControlJs1/', 'Custom/FrameworkControlJs1/Template.html');
    })(Controls = TcHmi.Controls || (TcHmi.Controls = {}));
})(TcHmi);